<?php

class Config {
	const sspPath = '../../lib/_autoload.php';
	
	// Keystone endpoint URLs
	const adminUrl = 'http://localhost:35357/v2.0/';
	const userUrl = 'http://localhost:5000/v2.0/';
	
	// Horizon dashboard URL
	const horizon = 'http://localhost:8000/auth/login/';
	
	// Admin AUTH token ( secret to communicate with keystone )
	const secret = '65e005728156f456cf20';
}

/*
 * In the Mapper class, you should define the function named by the auth source:
 * (replace special characters with underscore: example-userpass -> example_userpass)
 * @return: The tuple (username, email, tenant) or false to deny access (not eligible)
 */

class Mapper {
	
	function facebook($attr) {
		$name = 'fb_' . strtolower($attr['facebook.first_name'][0]) . '_' . strtolower($attr['facebook.last_name'][0]);
		return [ $name, $attr['facebook.email'][0], 'demo' ];
	}

	function admin($attr) {
		return [ 'admin', 'admin@root', null ];
	}
	
	function example_ldap($attr) {
		return [ $attr['uid'][0], $attr['mail'][0] , 'admin' ];
	}
}
