<?php
require_once('config.php');
require_once('keystone.php');
require_once( Config::sspPath );

class Openstack {
	
	function __construct( $source ) {
		$this->source = $source;
		$this->as = new SimpleSAML_Auth_Simple( $source );
		$this->ks = new Keystone;
	}
	
	function mapper() {
		$this->as->requireAuth();
		$attr = $this->as->getAttributes();
		
		// remove invalid function characters
		$source = preg_replace('/[^a-zA-z0-9]+/', '_', $this->source);
		
		$m = new Mapper;
		if ( !method_exists($m, $source) )
			throw new Exception("Please define a mapper for the $source AUTH source (hint: config.php).");
		return $m->$source($attr);
	}
	
	function login() {
		list($name, $mail, $tenant) = $this->mapper();
		if (!$name)
			die('Error: You are not eligible for the account.');
		$pass = substr(md5(lcg_value()), 0, 8);
		
		if ( $user = $this->ks->user($name) ) {
			$this->ks->changePass($user['id'], $pass);
		} else {
			$user = $this->ks->register($name, $mail, $pass, $tenant);
		}
		
		echo $this->postRedirect( htmlspecialchars($user['name']) , htmlspecialchars($pass) );
		
		return; // skip auth, that is done at the horizon side
		$token = $this->ks->auth($user['name'], $user['pass']);
	}
	
	function logout() {
		if ($this->as->isAuthenticated())
			$this->as->logout();
		return !$this->as->isAuthenticated();
	}
	
	static function sources() {
		return SimpleSAML_Auth_Source::getSources();
	}
	
	// form used for HTTP POST redirect
	function postRedirect($name, $pass) {
		$horizon = Config::horizon;
		$endpoint = Config::userUrl;
		return <<<FORM
Logging you in...
<form action="$horizon" style="display:none" method="post" name="form">
	<input name="username" value="$name" />
	<input name="password" value="$pass" />
	<input name="region" value="$endpoint" />
</form>
<script>
	document.forms['form'].submit();
</script>
FORM;
	}
}
